/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.ejb;

import java.util.List;

import javax.ejb.SessionBean;

import net.javajigi.user.ExistedUserException;
import net.javajigi.user.PasswordMismatchException;
import net.javajigi.user.UserNotFoundException;
import net.javajigi.user.dao.UserDAO;
import net.javajigi.user.dao.UserDAOFactory;
import net.javajigi.user.model.User;

public abstract class UserServiceBean implements SessionBean {
    public int addUser(User user) throws ExistedUserException {
        if (getUserDAO().existedUser(user.getUserId())) {
            throw new ExistedUserException(user.getUserId() + " ϴ ̵Դϴ.");
        }

        return getUserDAO().insert(user);
    }

    public int updateUser(User user) {
        return getUserDAO().update(user);
    }

    public int removeUser(String userId) {
        return getUserDAO().delete(userId);
    }

    public User findUser(String userId) throws UserNotFoundException {
        User user = getUserDAO().findUser(userId);

        if (user == null) {
            throw new UserNotFoundException(userId + "  ʴ ̵Դϴ.");
        }

        return user;
    }

    public List findUserList() {
        return getUserDAO().findUserList();
    }

    public boolean login(String userId, String password)
            throws PasswordMismatchException, UserNotFoundException {
        User user = findUser(userId);

        if (!user.isMatchPassword(password)) {
            throw new PasswordMismatchException("йȣ ġ ʽϴ.");
        }

        return true;
    }

    public UserDAO getUserDAO() {
        return UserDAOFactory.getUserDAO(UserDAOFactory.MYSQL_DB);
    }
}
