/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.spring;

import java.util.List;

import net.javajigi.user.ExistedUserException;
import net.javajigi.user.PasswordMismatchException;
import net.javajigi.user.UserNotFoundException;
import net.javajigi.user.dao.UserDAO;
import net.javajigi.user.model.User;
import net.javajigi.user.service.UserService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class SpringUserService implements UserService {
    protected static final Log logger = LogFactory.getLog(SpringUserService.class);
    
    private UserDAO userDAO = null;

    public void setUserDAO(UserDAO newUserDAO) {
        this.userDAO = newUserDAO;
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#create(net.javajigi.user.model.User)
     */
    public int addUser(User user) throws ExistedUserException {
		if (logger.isDebugEnabled()) {
			logger.debug("addUser() ");
			logger.debug("User : " + user);
		}        
        
        if (userDAO.existedUser(user.getUserId())) {
            throw new ExistedUserException(user.getUserId() + " ϴ ̵Դϴ.");
        }
        
		if (logger.isDebugEnabled()) {
			logger.debug("Added " + user.getUserId() + " in User System!!");
		}

		if (logger.isDebugEnabled()) {
			logger.debug("addUser() ");
		}

        return userDAO.insert(user);
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#update(net.javajigi.user.model.User)
     */
    public int updateUser(User user) {
		if (logger.isDebugEnabled()) {
			logger.debug("updateUser() ");
			logger.debug("User : " + user);
		}         
        
        return userDAO.update(user);
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#remove(java.lang.String)
     */
    public int removeUser(String userId) {
		if (logger.isDebugEnabled()) {
			logger.debug("removeUser() ");
			logger.debug("User ID : " + userId);
		}       
        
        return userDAO.delete(userId);
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#findUser(java.lang.String)
     */
    public User findUser(String userId) throws UserNotFoundException {
		if (logger.isDebugEnabled()) {
			logger.debug("findUser() ");
			logger.debug("User ID : " + userId);
		}         
        
        User user = userDAO.findUser(userId);

        if (user == null) {
            throw new UserNotFoundException(userId + "  ʴ ̵Դϴ.");
        }

        return user;
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#findUserList()
     */
    public List findUserList() {
		if (logger.isDebugEnabled()) {
			logger.debug("findUserList() ");
		}         
        
        return userDAO.findUserList();
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.javajigi.user.spring.UserService#login(java.lang.String,
     *      java.lang.String)
     */
    public boolean login(String userId, String password)
            throws PasswordMismatchException, UserNotFoundException {
		if (logger.isDebugEnabled()) {
			logger.debug("login() ");
			logger.debug("User ID : " + userId);
		}          
        
        User user = findUser(userId);

        if (!user.isMatchPassword(password)) {
            throw new PasswordMismatchException("йȣ ġ ʽϴ.");
        }

        return true;
    }

}
