/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.dao;

import junit.framework.TestCase;
import net.javajigi.user.model.User;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class MySQLUserDAOTest extends TestCase {

	private ApplicationContext ctx;

	private UserDAO userDAO;

	protected void setUp() throws Exception {
		String[] paths = { "/WEB-INF/applicationContext.xml" };
		ctx = new ClassPathXmlApplicationContext(paths);
		//String[] paths = { "chapter2/web/WEB-INF/applicationContext.xml" };
		//ctx = new FileSystemXmlApplicationContext(paths);

		userDAO = (UserDAO) ctx.getBean("userDAO");
	}

	private User populateUser() {
		User user = new User();
		user.setUserId("testuser");
		user.setPassword("password");
		user.setName("缺");
		user.setEmail("javajigi@gmail.com");
		user.setAdmin(false);

		return user;
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testAddAndFindAndDeleteUser() throws Exception {
		User user = populateUser();

		try {
			assertEquals(1, userDAO.insert(user));

			User dbUser = userDAO.findUser(user.getUserId());

			assertEquals(user, dbUser);
		} finally {
			assertEquals(1, userDAO.delete(user.getUserId()));
		}
	}

	public void testFindAndUpdateUser() throws Exception {
		User user = populateUser();

		try {
			assertEquals(1, userDAO.insert(user));

			user.setName("ڿ");
			user.setPassword("pass");
			user.setEmail("javajigi@javajigi.net");
			user.setAdmin(true);

			assertEquals(1, userDAO.update(user));

			User dbUser = userDAO.findUser(user.getUserId());

			assertEquals(user, dbUser);
		} finally {
			assertEquals(1, userDAO.delete(user.getUserId()));
		}
	}
}
