/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.service;

import junit.framework.TestCase;
import net.javajigi.user.PasswordMismatchException;
import net.javajigi.user.UserNotFoundException;
import net.javajigi.user.dao.UserDAO;
import net.javajigi.user.model.User;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.easymock.MockControl;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class EasyMockUserServiceTest extends TestCase {
	protected final Log logger = LogFactory.getLog(getClass());
	
	private MockControl control = null;

	private UserDAO mock = null;

	private UserService userService = null;

	protected void setUp() throws Exception {
		control = MockControl.createControl(UserDAO.class);
		mock = (UserDAO) control.getMock();

		String[] paths = { "/WEB-INF/applicationContext.xml" };
		ApplicationContext ctx = new ClassPathXmlApplicationContext(paths);
		
		userService = new UserServiceImpl();
		userService.setUserDAO(mock);
		userService.setApplicationContext(ctx);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testLogin() throws Exception {
		User user = populateUser();

		mock.findUser(user.getUserId());
		control.setReturnValue(user);
		control.replay();

		assertTrue(userService.login(user.getUserId(), user.getPassword()));
	}

	public void testLoginFailedUserNotFound() throws PasswordMismatchException {
		mock.findUser("javajigi");
		control.setReturnValue(null);
		control.replay();

		try {
			userService.login ("javajigi", "password");
			
			fail("ȯǴ User ü  Null̿ Ѵ.");
		} catch (UserNotFoundException e) {
			logger.error(e.getMessage());
			
			assertTrue(true);
		}
	}
	
	public void testLoginFailedPasswordMismatch() throws UserNotFoundException {
		User user = populateUser();
		
		mock.findUser(user.getUserId());
		control.setReturnValue(user);
		control.replay();

		try {
			userService.login (user.getUserId(), "pass");
			
			fail("αϰ ִ  йȣ Ʋ մϴ.");
		} catch (PasswordMismatchException e) {
			logger.error(e.getMessage());
			
			assertTrue(true);
		}
	}

	private User populateUser() {
		User user = new User();
		user.setUserId("javajigi");
		user.setPassword("password");
		user.setName("缺");
		user.setEmail("javajigi@gmail.com");
		return user;
	}
}
