package net.javajigi.advice;

import net.javajigi.common.mail.ExceptionMailSender;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public aspect EmailNotificationAspect {
	protected final Log logger = LogFactory.getLog(getClass());
	
	private ExceptionMailSender mailSender;

	public void setMailSender(ExceptionMailSender mailSender) {
		this.mailSender = mailSender;
	}
	
	protected pointcut runtimeExceptions()
    : ( execution(public * net.javajigi.user.service.UserServiceImpl*.*(..)) );
	
	after() throwing (RuntimeException ex) :  runtimeExceptions () {
		if (logger.isDebugEnabled()) {
			logger.debug("net.javajigi.advice.EmailNotificationAspect.runtimeExceptions() ");
			logger.debug("Caught : " + ex.getClass().getName());
		}
		
		mailSender.sendMessage(ex);
		
		if (logger.isDebugEnabled()) {
			logger.debug("net.javajigi.advice.EmailNotificationAspect.runtimeExceptions() ");
		}		
	}
}
