/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.service;

import junit.framework.TestCase;
import net.javajigi.advice.EmailNotificationThrowsAdvice;
import net.javajigi.advice.UserLoggingAdvice;
import net.javajigi.user.dao.UserDAO;
import net.javajigi.user.model.User;

import org.easymock.MockControl;
import org.springframework.aop.framework.ProxyFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class EmailNotificationUserServiceTest extends TestCase {
	private MockControl control = null;

	private UserDAO mock = null;
	
	private ApplicationContext ctx = null;

	protected void setUp() throws Exception {
		control = MockControl.createControl(UserDAO.class);
		mock = (UserDAO) control.getMock();
		
		String[] paths = { "/WEB-INF/applicationContext.xml" };
		ApplicationContext ctx = new ClassPathXmlApplicationContext(paths);
	}

	public void testLogin() throws Exception {
		User user = new User();
		user.setUserId("javajigi");
		user.setPassword("password");
		user.setName("缺");
		user.setEmail("javajigi@gmail.com");

		mock.findUser(user.getUserId());
		control.setReturnValue(user);
		control.replay();

		UserService target = new UserServiceImpl();
		target.setUserDAO(mock);

		ProxyFactory pf = new ProxyFactory();
		pf.addAdvice(new UserLoggingAdvice());
		pf.addAdvice(new EmailNotificationThrowsAdvice());
		pf.setTarget(target);

		UserService userService = (UserService) pf.getProxy();

		assertTrue(userService.login(user.getUserId(), user.getPassword()));
	}
}

