/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.service;

import java.util.List;

import javax.ejb.CreateException;

import net.javajigi.user.ExistedUserException;
import net.javajigi.user.PasswordMismatchException;
import net.javajigi.user.UserNotFoundException;
import net.javajigi.user.model.User;

import org.springframework.ejb.support.AbstractStatelessSessionBean;

public class UserServiceEJB extends AbstractStatelessSessionBean implements
        UserService {
    private static final String BEAN_NAME = "userService";

    private UserService userService;

    protected void onEjbCreate() throws CreateException {
        userService = (UserService) getBeanFactory().getBean(BEAN_NAME);
    }

    public int addUser(User user) throws ExistedUserException {
        return userService.addUser(user);
    }

    public int updateUser(User user) {
        return userService.updateUser(user);
    }

    public int removeUser(String userId) {
        return userService.removeUser(userId);
    }

    public User findUser(String userId) throws UserNotFoundException {
        return userService.findUser(userId);
    }

    public List findUserList() {
        return userService.findUserList();
    }

    public boolean login(String userId, String password)
            throws PasswordMismatchException, UserNotFoundException {
        return userService.login(userId, password);
    }
}
