package net.javajigi.advice;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.aspectj.lang.Signature;

/**
 * ּ ־ ּ. 谡 Ŀ.
 * 
 * @author 缺(ڹ, javajigi@gmail.com)
 */
public aspect LoggingAspect {
    protected final Log logger = LogFactory.getLog(getClass());

    pointcut traceMethods()
        : (execution(* net.javajigi.user.dao..*.*(..)) 
                || execution(* net.javajigi.user.service..*.*(..)) );

    before() : traceMethods(){
        Signature sig = thisJoinPointStaticPart.getSignature();

        if (logger.isDebugEnabled()) {
            logger.debug("Entering [" + sig.getDeclaringTypeName() + "."
                    + sig.getName() + "]");
        }
    }
    
    after() :  traceMethods(){
        Signature sig = thisJoinPointStaticPart.getSignature();

        if (logger.isDebugEnabled()) {
            logger.debug("Exit [" + sig.getDeclaringTypeName() + "."
                    + sig.getName() + "]");
        }
    }
}
