/**
 *  ҽ Spring ӿũ ũϿ   ҽԴϴ. 
 *  ҽ  ڵ Ӱ     ֽϴ. 
 * ,  ҽ  ο ø̼   ó  ֽø ˴ϴ. 
 */
package net.javajigi.user.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.javajigi.user.PasswordMismatchException;
import net.javajigi.user.UserNotFoundException;
import net.javajigi.user.model.Authenticate;
import net.javajigi.user.model.User;
import net.javajigi.user.service.UserService;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;
import org.apache.struts.actions.DispatchAction;

public class LoginAction extends DispatchAction {
	private UserService userService = null;

	public void setUserService(UserService userService) {
		this.userService = userService;
	}

	public ActionForward login(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm userForm = (DynaActionForm) form;
		Authenticate auth = (Authenticate) userForm.get("authenticate");
		try {
			userService.login(auth.getUserId(), auth.getPassword());

			User user = userService.findUser(auth.getUserId());
			user.setPassword(null);
			HttpSession session = request.getSession();
			session.setAttribute("loginUser", user);

			return mapping.findForward("index");
		} catch (UserNotFoundException e) {
			request.setAttribute("errorMessage", e.getMessage());

			return mapping.getInputForward();
		} catch (PasswordMismatchException e) {
			request.setAttribute("errorMessage", e.getMessage());
			
			return mapping.getInputForward();
		}
	}

	public ActionForward logout(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		HttpSession session = request.getSession();
		session.removeAttribute("loginUser");

		return mapping.findForward("index");
	}
}
