<%@page contentType="text/html; charset=utf-8"%>
<%@ taglib uri="http://java.sun.com/jstl/core_rt" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jstl/fmt_rt" prefix="fmt" %>

<div id="menu">
<fieldset><legend>Menu</legend>
	<ul>		
	 	<li>
	 		<a href="${pageContext.request.contextPath}/index.html">
	 			<fmt:message key="app.home"/>
	 		</a>
	 	</li>
		<li>
			<a href="${pageContext.request.contextPath}/board/board.do?method=list">
				<fmt:message key="app.board"/>
			</a>
		</li>
<c:if test="${loginUser.admin}">
		<li>
			<a href="${pageContext.request.contextPath}/user/user.do?method=list">
				<fmt:message key="app.user"/>
			</a>
		</li>
</c:if>		
		<li>
			<a href="http://www.javajigi.net" target="_blank">
				<fmt:message key="app.community"/>
			</a>
		</li>
		<li>
			<a href="http://wiki.javajigi.net" target="_blank">
				<fmt:message key="app.wiki"/>
			</a>
		</li>
	</ul>
</fieldset>	
</div>

<c:choose>
<c:when test="${not empty loginUser}">
<c:if test="${not empty errorMessage }">
<br/>
<p><b><fmt:message key="error.message"/></b> : 
<span class="fieldError"><c:out value="${errorMessage}"/></span>
</p>
</c:if>
<div id="authentication">
<form action="${pageContext.request.contextPath}/user/login.do"
	id="thisform" method="post" name="authForm">
	<input type="hidden" name="method" value="logout"/>
	<fieldset>
		<legend><fmt:message key="user.logout.title"/></legend>	
		<input type="hidden" name="userId" value="${loginUser.userId}"/>		
		<p>${loginUser.name} <fmt:message key="login.welcome.message"/></p>
		<p>
			<center>
				<input type="submit" name="logout" value="<fmt:message key="user.logout.button"/>"/>&nbsp;
				<input type="button" value="<fmt:message key="user.modify.button"/>"
					onClick="location.href='${pageContext.request.contextPath}/user/user.do?method=editForm&userId=${loginUser.userId}'" />
			</center>
		</p>
	</fieldset>
</form>
</div>
</c:when> 
<c:otherwise>
<div id="authentication">
<form action="${pageContext.request.contextPath}/user/login.do"
	id="thisform" method="post" name="authenticationForm">
	<input type="hidden" name="method" value="login"/>
	<fieldset>
		<legend><fmt:message key="user.login.title"/></legend>
			<p><label for="name" accesskey="9"><fmt:message key="user.id"/> :</label><br />
				<input type="text" id="userId" name="authenticate.userId" style="width:150"/>
			</p>
			<p><label for="password"><fmt:message key="user.password"/> :</label><br />
				<input type="password" id="password" name="authenticate.password" style="width:150"/>				
			</p>
			<c:if test="${not empty errorMessage}">
			<p>
				<span class="fieldError">${errorMessage}</span>
			</p>
			</c:if>
			<p>
				<center>
				<input type="submit" name="login" value="<fmt:message key="user.login.button"/>"/>&nbsp;
				<input type="button" value="<fmt:message key="user.add.button"/>"
					onClick="location.href='${pageContext.request.contextPath}/user/user.do?method=editForm'" />
			</center>
			</p>
</fieldset>
</form>
</div>
</c:otherwise>  
</c:choose>
